// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlListBox")]
    pub struct ListBox(Object<ffi::DzlListBox, ffi::DzlListBoxClass>) @extends gtk::ListBox, gtk::Container, gtk::Widget, @implements gtk::Buildable;

    match fn {
        type_ => || ffi::dzl_list_box_get_type(),
    }
}

impl ListBox {
    pub const NONE: Option<&'static ListBox> = None;

    #[doc(alias = "dzl_list_box_new")]
    pub fn new(row_type: glib::types::Type, property_name: &str) -> ListBox {
        assert_initialized_main_thread!();
        unsafe {
            gtk::Widget::from_glib_none(ffi::dzl_list_box_new(
                row_type.into_glib(),
                property_name.to_glib_none().0,
            ))
            .unsafe_cast()
        }
    }
}

mod sealed {
    pub trait Sealed {}
    impl<T: super::IsA<super::ListBox>> Sealed for T {}
}

pub trait ListBoxExt: IsA<ListBox> + sealed::Sealed + 'static {
    #[doc(alias = "dzl_list_box_get_model")]
    #[doc(alias = "get_model")]
    fn model(&self) -> Option<gio::ListModel> {
        unsafe { from_glib_none(ffi::dzl_list_box_get_model(self.as_ref().to_glib_none().0)) }
    }

    #[doc(alias = "dzl_list_box_get_property_name")]
    #[doc(alias = "get_property_name")]
    fn property_name(&self) -> Option<glib::GString> {
        unsafe {
            from_glib_none(ffi::dzl_list_box_get_property_name(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_list_box_get_row_type")]
    #[doc(alias = "get_row_type")]
    fn row_type(&self) -> glib::types::Type {
        unsafe {
            from_glib(ffi::dzl_list_box_get_row_type(
                self.as_ref().to_glib_none().0,
            ))
        }
    }

    #[doc(alias = "dzl_list_box_set_model")]
    fn set_model(&self, model: &impl IsA<gio::ListModel>) {
        unsafe {
            ffi::dzl_list_box_set_model(
                self.as_ref().to_glib_none().0,
                model.as_ref().to_glib_none().0,
            );
        }
    }

    #[cfg(feature = "v3_28")]
    #[cfg_attr(docsrs, doc(cfg(feature = "v3_28")))]
    #[doc(alias = "dzl_list_box_set_recycle_max")]
    fn set_recycle_max(&self, recycle_max: u32) {
        unsafe {
            ffi::dzl_list_box_set_recycle_max(self.as_ref().to_glib_none().0, recycle_max);
        }
    }
}

impl<O: IsA<ListBox>> ListBoxExt for O {}

impl fmt::Display for ListBox {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("ListBox")
    }
}
